(***************************************************************)
(* Coq code for OCAP                                           *)
(*                                                             *)
(* OCAP                                                        *)
(*                                                             *)
(*                                                             *)
(***************************************************************)

(* $Id: ocap_2.v,v 1.1.1.1 2006/12/07 16:43:22 ssg05 Exp $ *)

Require Import ocap.
Require Import bnat.
Require Import extac.

Ltac des_opsi H :=
  let Hpi := fresh "Hpi" in 
    (destruct H as [H | Hpi]; 
      [
        match goal with
          | H : pairT ?f ?pi1 = pairT ?f ?pi2 |- _ =>
            inversion_clear H 
          | H : pairT ?f1 ?pi1 = pairT ?f2 ?pi2,
            H1 : ?f2 <> ?f1 |- _ =>
            inversion H; subst; destruct (H1 (refl_equal _))
          | H : pairT ?f1 ?pi1 = pairT ?f2 ?pi2 |- _ =>
            discriminate H 
          | H : False |- _ =>
            destruct H
          | _ => fail 1 "unexpect error"
        end
        | 
        match goal with
          | H : False |- _ =>
            destruct H 
          | H : pairT ?f1 ?pi1 = pairT ?f2 ?pi2 \/ ?B 
            |- _ => des_opsi Hpi
          | _ => idtac
        end
      ]).

Ltac opsi_lookup label :=  
  match goal with
    | H : OCHSpec.lookup ?psi ?f ?pi |- _ =>
      let Heq := fresh "Heq" in 
      let Hneq := fresh "Hneq" in 
        (destruct (nat_eq_dec f label) as [Heq | Hneq]);
      [ unfold OCHSpec.lookup in H;
        unfold psi in H;
          subst;
          simpl in H ; des_opsi H| idtac]
    | _ => idtac
  end.


Ltac opsi_lookup_not :=
  match goal with 
    | H : OCHSpec.lookup ?psi ?f ?pi |- _ =>
       unfold OCHSpec.lookup in H;
        unfold psi in H;
        simpl in H;
          des_opsi H
    | _ => idtac
  end.
