(***************************************************************)
(* Coq code for OCAP                                           *)
(*                                                             *)
(* Typed Assembly Language                                     *)
(*                                                             *)
(* tal-0, some useful lemmas & tactics                         *)
(***************************************************************)

(* $Id: tal0_2.v,v 1.1.1.1 2006/12/07 16:43:19 ssg05 Exp $ *)

Require Import bnat.
Require Import tal0.
Require Import extac.

Ltac psi_lookup label :=
  match goal with
    | H : CHSpec.lookup ?psi ?f ?a
      |- _ =>
      decbeqnat f label;
      [ substH H with (@CHSpec.lookup_get psi f a H);
        unfold CHSpec.get, CHSpec.get, CHSpecDef.get in H;
        unfold psi in H;
        simplbnat;
        substbnat f;
        simpl in H;
          (match type of H with 
             | None = Some a  => discriminate H
             | Some ?b = Some a =>  inj_hyp H; subst a
           end)
        | idtac]
    | _ => idtac
  end.

Ltac psi_lookup_not :=
  match goal with
    | H : CHSpec.lookup ?psi ?f ?a |- _ =>
      substH H with (@CHSpec.lookup_get psi f a H);
      unfold CHSpec.get, CHSpec.get, CHSpecDef.get in H;      
      unfold psi in H; simplbnat; simpl in H;
        (match type of H with
           | None = Some a => discriminate H
           | _ => fail
         end)
    | _ => fail
  end.
