(***************************************************************)
(* Coq code for OCAP                                           *)
(*                                                             *)
(* Instruction                                                 *)
(*     MIPS-style                                              *)
(*                                                             *)
(***************************************************************)

(* $Id: Instr.v,v 1.1.1.1 2006/12/07 16:43:17 ssg05 Exp $ *)

Require Import Reg.
Require Import Word.

Inductive instr : Set :=
  | addu : forall (rd : reg) (rs : reg) (rt : reg), instr
  | addiu : forall (rd : reg) (rs : reg) (w : word), instr
  | subu : forall (rd : reg) (rs : reg) (rt : reg), instr
  | subiu : forall (rd : reg) (rs : reg) (w : word), instr
  | move : forall (rd : reg) (rs : reg), instr
  | li : forall (rd : reg) (w : word), instr
  | lw : forall (rt : reg) (i : word) (rs : reg), instr
  | sw : forall (rt : reg) (i : word) (rs : reg), instr
  | blt : forall (rs : reg) (rt : reg) (f : word), instr
  | beq : forall (rs : reg) (rt : reg) (f : word), instr
  | bgtz : forall (rs : reg) (f : word), instr
  | j : forall (f : word), instr
  | jal : forall (f fret : word), instr
  | jr : forall (r : reg), instr.

Definition B := instr.

Implicit Types i : instr.

Inductive instrseq : Set :=
  | ione : instr -> instrseq
  | iseq : instr -> instrseq -> instrseq.

Implicit Types is : instrseq.
