Require Import Map.
Require Import TM.
Require Import Assertions.
Require Import CSL.
Require Import AuxLib.

Lemma CSL_FrameInstr : forall Psi Gamma v c v' m,
                       CSL_WFInstr Psi Gamma (csl_spec v) c (csl_spec v') ->
                       CSL_WFInstr (star_Psi Psi m) Gamma (csl_spec (star_am v m)) c (csl_spec (star_am v' m)).
Proof.
intros Y T v c v' m HI.
inversion_clear HI.

(* addu *)
constructor.
intros M R k L M' R' Hnext Ht.
inversion_clear Ht as [M1 (M2,(Hdis,(Huni,(Hv,Hm))))].
rewrite Huni in Hnext.
clear M Huni.
inversion Hnext.
clear Hnext M' R' M R0 rd0 rs0 rt0 H1 H2 H3 H4 H5 H6 H7.
exists M1.
exists M2.
split.
auto.
split.
auto.
split.
apply H with M1 R.
constructor.
auto.
auto.

(* cons *)
constructor.
intros M R k L Ht l Hl HSl w w' X Hx.
rewrite Hx.
clear X Hx.
inversion_clear Ht as [M1 (M2,(Hdis,(Huni,(Hv,Hm))))].
rewrite Huni in Hl.
rewrite Huni in HSl.
rewrite Huni.
clear M Huni.
exists (ext_M (ext_M M1 l w) (S l) w').
exists M2.
split.
unfold dis_M.
apply disjoint_commut.
apply dis_ext.
apply dis_ext.
unfold dis_M.
apply disjoint_commut; auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
rewrite <- uni_ext.
apply dom_ext.
auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
unfold dis_M.
apply disjoint_commut; auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
split.
unfold uni_M.
rewrite disj_merge_commut.
rewrite uni_ext.
rewrite uni_ext.
rewrite disj_merge_commut.
auto.
apply dis_ext.
apply dis_ext.
unfold dis_M.
apply disjoint_commut; auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
rewrite <- uni_ext.
apply dom_ext.
auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
unfold dis_M.
apply disjoint_commut; auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
apply dis_ext.
unfold dis_M.
apply disjoint_commut; auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
rewrite <- uni_ext.
apply dom_ext.
auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
unfold dis_M.
apply disjoint_commut; auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
unfold dis_M.
apply disjoint_commut; auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
auto.
split.
apply H with M1 R k L l w w'.
auto.
apply dom_uni with M2.
unfold dis_M.
apply disjoint_commut; auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
apply dom_uni with M2.
unfold dis_M.
apply disjoint_commut; auto.
rewrite disj_merge_commut.
auto.
apply disjoint_commut; auto.
auto.
auto.

(* free *)
constructor.
intros M R k L Ht.
inversion_clear Ht as [M1 (M2,(Hdis,(Huni,(Hv,Hm))))].
rewrite Huni.
clear M Huni.
elim (H M1 R k L Hv).
intros M1' (R',(Hnext,Hv')).
inversion Hnext.
rename H2 into Hdom.
rewrite <- H4 in Hv'.
rewrite <- H5 in Hv'.
rewrite <- H5 in Hdom.
rewrite <- H5.
clear Hnext R' M1' R0 M rs0 H0 H1 H3 H4 H5.
exists (remove_M (uni_M M1 M2) (R rs)).
exists R.
split.
constructor.
unfold uni_M.
rewrite disj_merge_commut.
apply dom_dom.
unfold dis_M.
apply disjoint_commut; auto.
auto.
auto.
exists (remove_M M1 (R rs)).
exists M2.
split.
unfold dis_M.
apply disjoint_commut.
apply dis_rem.
unfold dis_M.
apply disjoint_commut; auto.
auto.
split.
unfold uni_M.
rewrite disj_merge_commut.
rewrite uni_rem.
rewrite disj_merge_commut.
auto.
apply dis_rem.
unfold dis_M.
apply disjoint_commut; auto.
auto.
unfold dis_M.
apply disjoint_commut; auto.
auto.
auto.
split.
auto.
auto.

(* sw *)
constructor.
intros M R k L Ht.
inversion_clear Ht as [M1 (M2,(Hdis,(Huni,(Hv,Hm))))].
rewrite Huni.
clear M Huni.
elim (H M1 R k L Hv).
intros M1' [R' (Hnext,Hv')].
inversion Hnext.
rename H1 into Hhas.
rewrite <- H6 in Hv'.
rewrite <- H7 in Hv'.
rewrite <- H7.
rewrite <- H7 in Hhas.
clear Hnext rt0 w0 rs0 M R0 M1' R' H0 H2 H3 H4 H5 H6 H7.
exists (ext_M (uni_M M1 M2) (R rs+w) (R rt)).
exists R.
split.
constructor.
unfold has_M.
unfold uni_M.
rewrite disj_merge_commut.
apply dom_dom.
unfold dis_M.
apply disjoint_commut; auto.
auto.
auto.
exists (ext_M M1 (R rs+w) (R rt)).
exists M2.
split.
unfold dis_M.
apply disjoint_commut.
apply dis_ext2.
unfold dis_M.
apply disjoint_commut; auto.
auto.
split.
unfold uni_M.
rewrite disj_merge_commut.
rewrite uni_ext2.
rewrite disj_merge_commut.
auto.
apply dis_ext2.
unfold dis_M.
apply disjoint_commut; auto.
auto.
unfold dis_M.
apply disjoint_commut; auto.
auto.
auto.
split.
auto.
auto.

(* lock *)
rename H into Hlock.
rename m0 into m'.
apply CSL_WFInstr_lock with m'.
auto.
intros M R k L Ht.
inversion_clear Ht as [M1 (M2,(Hdis,(Huni,(Hvm,Hm'))))].
rewrite Huni.
clear Huni M.
inversion_clear Hvm as [M1_1 (M1_2,(Hdis1,(Huni,(Hv,Hm))))].
rewrite Huni in Hdis.
rewrite Huni.
clear M1 Huni.
exists (uni_M M1_1 M2).
exists M1_2.
split.
apply uni_dis.
auto.
unfold dis_M.
apply disjoint_commut.
apply uni_disll with M1_1 (emp (A:=Address) Word).
unfold uni_M.
rewrite disj_merge_commut.
rewrite mer_empr.
auto.
apply disjoint_commut; auto.
split.
rewrite <- (uni_emp (emp (A:=Address) Word) M1_1 M1_2 M2).
rewrite <- (uni_emp (emp (A:=Address) Word) M1_1 M2 M1_2).
unfold uni_M.
assert (disjoint M1_2 M2).
apply uni_disll with M1_1 (emp (A:=Address) Word).
unfold uni_M.
rewrite disj_merge_commut.
rewrite mer_empr.
auto.
apply disjoint_commut; auto.
rewrite (disj_merge_commut H).
auto.
compute; auto.
unfold dis_M.
apply disjoint_commut.
apply uni_disll with M1_1 (emp (A:=Address) Word).
unfold uni_M.
rewrite disj_merge_commut.
rewrite mer_empr.
auto.
apply disjoint_commut; auto.
compute; auto.
apply uni_disll with M1_1 (emp (A:=Address) Word).
unfold uni_M.
rewrite disj_merge_commut.
rewrite mer_empr.
auto.
apply disjoint_commut; auto.
split.
apply H0.
exists M1_1.
exists M2.
split.
apply uni_disll with M1_2 (emp (A:=Address) Word).
rewrite mer_empr.
auto.
auto.
auto.

(* unlock *)
rename H into Hlock.
rename m0 into m'.
apply CSL_WFInstr_unlock with m'.
auto.
intros M R k L Ht.
inversion_clear Ht as [M1 (M2,(Hdis,(Huni,(Hv,Hm))))].
rewrite Huni.
clear M Huni.
elim (H0 M1 R k L Hv).
clear H0.
intros Hmaps Ht.
inversion_clear Ht as [M1_1 (M1_2,(Hdis1,(Huni,(Hv',Hm'))))].
rewrite Huni in Hdis.
rewrite Huni in Hv.
rewrite Huni.
clear M1 Huni.
split.
auto.
exists (uni_M M1_1 M2).
exists M1_2.
split.
apply uni_dis.
auto.
unfold dis_M.
apply disjoint_commut.
apply uni_disll with M1_1 (emp (A:=Address) Word).
unfold uni_M.
rewrite disj_merge_commut.
rewrite mer_empr.
auto.
apply disjoint_commut; auto.
split.
rewrite <- (uni_emp (emp (A:=Address) Word) M1_1 M2 M1_2).
rewrite <- (uni_emp (emp (A:=Address) Word) M1_1 M1_2 M2).
unfold uni_M.
assert (disjoint M1_2 M2).
apply uni_disll with M1_1 (emp (A:=Address) Word).
unfold uni_M.
rewrite disj_merge_commut.
rewrite mer_empr.
auto.
apply disjoint_commut; auto.
rewrite (disj_merge_commut H).
auto.
compute; auto.
apply uni_disll with M1_1 (emp (A:=Address) Word).
unfold uni_M.
rewrite disj_merge_commut.
rewrite mer_empr.
auto.
apply disjoint_commut; auto.
compute; auto.
unfold dis_M.
apply disjoint_commut.
apply uni_disll with M1_1 (emp (A:=Address) Word).
unfold uni_M.
rewrite disj_merge_commut.
rewrite mer_empr.
auto.
apply disjoint_commut; auto.
split.
exists M1_1.
exists M2.
split.
apply uni_disll with M1_2 (emp (A:=Address) Word).
rewrite mer_empr.
auto.
split.
auto.
split.
auto.
auto.
auto.


(* bgtz *)
rename H into Hgetv''.
apply CSL_WFInstr_bgtz with (star_am v'' m).
unfold star_Psi.
rewrite Hgetv''.
auto.
intros M R k L Ht.
inversion_clear Ht as [M1 (M2,(Hdis,(Huni,(Hv,Hm))))].
elim (H0 M1 R k L Hv).
intros Hgt Hle.
split; intro Hcond.
exists M1.
exists M2.
auto.
exists M1.
exists M2.
auto.
Qed.

Lemma CSL_FrameIseq : forall I Psi Gamma v m,
                      CSL_WFIseq Psi Gamma (csl_spec v) I ->
                      CSL_WFIseq (star_Psi Psi m) Gamma (csl_spec (star_am v m)) I.
Proof.
induction I.
intros Psi Gamma v m HI.
inversion_clear HI.
rename H into Hi.
rename H0 into HI'.
apply CSL_WFIseq_seq with (star_am v' m).
apply CSL_FrameInstr.
auto.
apply IHI.
auto.

(* jr *)
intros Psi Gamma v m HI.
inversion_clear HI.
apply CSL_WFIseq_jr with (star_am v' m).
intros M R k L Ht.
inversion_clear Ht as [M1 (M2,(Hdis,(Huni,(Hv,Hm))))].
elim (H M1 R k L).
intros Hgetv' Hv'.
split.
unfold star_Psi.
rewrite Hgetv'.
auto.
exists M1.
exists M2.
auto.
auto.
Qed.
